mysite/myauth/urls.py
from django.urls import path
from .views import (login_view, get_cookie_view, set_cookie_view, get_session_view, set_session_view, \
    logout_view, MyLogoutView, AboutMeView, RegisterView, FooBarView, ProfileUpdate, UserListView, UserDetail,
                    UpdateView, UserUpdate, HelloView)
from django.contrib.auth.views import LoginView

app_name='myauth'

urlpatterns=[
    #path('login/', login_view, name='login')
    path('login/',
         LoginView.as_view(template_name='myauth/login.html', redirect_authenticated_user=True),
         name='login'),
    # path('logout/', logout_view, name='logout'),
    path('logout/', MyLogoutView.as_view(), name='logout'),
    path('cookie/get', get_cookie_view, name='cookie-get'),
    path('cookie/set', set_cookie_view, name='cookie-set'),
    path('session/get', get_session_view, name='session-get'),
    path('session/set', set_session_view, name='session-set'),
    path('about-me/', AboutMeView.as_view(), name='about-me'),
    path('register/', RegisterView.as_view(), name='register'),
    path('foo-bar', FooBarView.as_view(), name='foo-bar'),
    path('users/', UserListView.as_view(), name='users'),
    path('users/<int:pk>', UserDetail.as_view(), name='users_detail'),
    path('users/<int:pk>/change', UserUpdate.as_view(), name='change_profile'),
    path('hello/', HelloView.as_view(), name='hello')
]

mysite/mysite/urls.py
from django.conf.urls.i18n import i18n_patterns
from django.conf.urls.static import static
from django.contrib import admin
from django.contrib.sitemaps.views import sitemap
from django.urls import path, include
from django.conf import settings

from drf_spectacular.views import SpectacularAPIView, SpectacularRedocView, SpectacularSwaggerView

from .sitemaps import sitemaps

urlpatterns = [
    path('admin/doc/', include('django.contrib.admindocs.urls')),
    path('admin/', admin.site.urls),
    path('requestdataapp/', include('requestdataapp.urls')),
    path('api/schema/', SpectacularAPIView.as_view(),name='schema'),
    path('api/schema/swagger/', SpectacularSwaggerView.as_view(url_name='schema'),name='swagger'),
    path('api/schema/redoc/', SpectacularRedocView.as_view(url_name='schema'),name='redoc'),
    path('api/', include('myapiapp.urls')),
    path('blogapp/', include('blogapp.urls')),
    path('news/', include('newsapp.urls')),
    path('sitemap.xml', sitemap, {'sitemaps': sitemaps}, name='sitemap')
]

urlpatterns+=i18n_patterns(
    path('myauth/', include('myauth.urls')),
    path('shopapp/', include('shopapp.urls')),

)

if settings.DEBUG:
    urlpatterns.extend(
        static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)
    )
    urlpatterns.extend(
        static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
    )
    urlpatterns.append(path('__debug__/' ,include('debug_toolbar.urls')))

mysite/shopapp/urls.py
from django.contrib import admin
from django.urls import path, include
from django.views.decorators.cache import cache_page
from rest_framework.routers import DefaultRouter
from .views import ShopIndexView, GroupsListView, \
    OrdersListView, create_product, create_order, ProductDetailsView, ProductsListView,\
    OrderDetailView, ProductCreateView, ProductUpdateView, ProductDeleteView, OrderUpdateView, \
    OrderDeleteView, ProductsDataExportView, OrdersDataExportView, ProductViewSet, OrderViewSet, \
    LatestArticlesFeed, UserOrdersView, UserOrderExportView

app_name='shopapp'

routers=DefaultRouter()
routers.register('products', ProductViewSet)
routers.register('orders', OrderViewSet)

urlpatterns = [
    path('', cache_page(120)(ShopIndexView.as_view()), name='index'),
    path('groups/',GroupsListView.as_view(), name='groups'),
    path('products/', ProductsListView.as_view(), name='products'),
    path('products/create/', ProductCreateView.as_view(), name='product_create'),
    path('products/<int:pk>', ProductDetailsView.as_view(), name='products_details'),
    path('products/<int:pk>/update', ProductUpdateView.as_view(), name='products_update'),
    path('products/<int:pk>/delete', ProductDeleteView.as_view(), name='products_delete'),
    path('products/latest/feed/', LatestArticlesFeed(), name='products_lasted_feed'),
    path('products/export', ProductsDataExportView.as_view(), name='products-export'),
    path('orders/', OrdersListView.as_view(), name='orders'),
    path('orders/<int:pk>', OrderDetailView.as_view(), name='order_detail'),
    path('orders/<int:pk>/update', OrderUpdateView.as_view(), name='order_update'),
    path('orders/<int:pk>/delete', OrderDeleteView.as_view(), name='order_delete'),
    path('create-product/', create_product, name='create_product'),
    path('create-order/', create_order,name='create_order'),
    path('orders/export', OrdersDataExportView.as_view(), name='orders-export'),
    path('api/', include(routers.urls)),
    path('users/<int:pk>/orders/', UserOrdersView.as_view(), name='user-orders'),
    path('users/<int:pk>/orders/export/', UserOrderExportView.as_view(), name='user-orders-export'),



]

mysite/shopapp/models.py
from django.contrib.auth.models import User
from django.db import models
from django.urls import reverse
from django.utils.translation import gettext_lazy


def product_preview_directory_path(instanse: "Product", filename: str) -> str:
    return f'products/product_{instanse.pk}/preview/{filename}'

def product_images_directory_path(instanse: "ProductImage", filename: str) -> str:
    return f'products/product_{instanse.product.pk}/images/{filename}'




class Product(models.Model):
    """
    Модель Product представляет товар, который можно продавать в интернет-магазине.

    Заказы тут: :model:`shopapp.Order`
    """
    class Meta:
        ordering = ['name']
        verbose_name = gettext_lazy('Product')
        verbose_name_plural = gettext_lazy('Products')

    name = models.CharField(max_length=100, db_index=True)
    description = models.TextField(null=False, blank=True, db_index=True)
    price = models.DecimalField(default=0, max_digits=15, decimal_places=2)
    discount = models.SmallIntegerField(default=0)
    created_at = models.DateField(auto_now_add=True)
    archivade = models.BooleanField(default=False)
    created_by = models.ForeignKey(User, on_delete=models.PROTECT)
    preview = models.ImageField(null=True, blank=True, upload_to=product_preview_directory_path)

    # @property
    # def descriprion_short(self):
    #     if(len(self.description))<48:
    #         return self.description
    #     return self.description[:48]+'...'

    def get_absolute_url(self):
        return reverse('shopapp:products_details', kwargs={'pk':self.pk})

    def __str__(self):
        return f'{self.name}: {self.price}'


class ProductImage(models.Model):
    product = models.ForeignKey(Product, on_delete=models.CASCADE, related_name='images')
    image=models.ImageField(upload_to=product_images_directory_path)
    description=models.CharField(max_length=200, null=False, blank=True)


class Order(models.Model):
    class Meta:
        verbose_name = gettext_lazy('Order')
        verbose_name_plural = gettext_lazy('Orders')

    delivery_adress = models.TextField(null=False, blank=True)
    promocode = models.CharField(max_length=20)
    created_at = models.DateField(auto_now_add=True)
    user = models.ForeignKey(User, on_delete=models.PROTECT)
    products = models.ManyToManyField(Product, related_name='orders')
    recipt = models.FileField(null=True, upload_to='orders/recipts')

    def __str__(self):
        return f'Adress: {self.delivery_adress}; User: {self.user}; Products: {self.products}'

mysite/shopapp/views.py
"""
В этом модуле различные представления.

Разные представления для интернет-магазина:
по товарам, заказам и т.д.
"""

import logging
from csv import DictWriter
from timeit import default_timer

from django.contrib.auth.mixins import LoginRequiredMixin, \
    PermissionRequiredMixin, UserPassesTestMixin
from django.contrib.syndication.views import Feed
from django.core.cache import cache
from django.http import HttpRequest, HttpResponseRedirect, \
    JsonResponse, HttpResponse, HttpResponseNotFound
from django.shortcuts import render, redirect, reverse
from django.contrib.auth.models import Group, User
from django.urls import reverse_lazy
from django.utils.decorators import method_decorator
from django.views import View
from django.views.decorators.cache import cache_page
from django.views.generic import ListView, DetailView, CreateView, \
    UpdateView, DeleteView
from django_filters.rest_framework import DjangoFilterBackend
from rest_framework.decorators import action
from rest_framework.parsers import MultiPartParser
from rest_framework.request import Request
from rest_framework.response import Response

from .forms import OrdersForm, ProductForm, GroupForm
from .models import Product, Order, ProductImage
from .serializers import ProductSerializer, OrderSerializer
from .common import save_scv_products

from rest_framework.viewsets import ModelViewSet
from rest_framework.filters import SearchFilter, OrderingFilter

from drf_spectacular.utils import extend_schema, OpenApiResponse

logger = logging.getLogger(__name__)


@extend_schema(description='Product views CRUD')
class ProductViewSet(ModelViewSet):
    """
    Набор представлений для действий над Product.

    Полный CRUD для сущности товара
    """

    queryset = Product.objects.all()
    serializer_class = ProductSerializer
    filter_backends = [
        SearchFilter,
        DjangoFilterBackend,
        OrderingFilter
    ]
    search_fields = ['name', 'description']
    filterset_fields = [
        'name',
        'description',
        'price'
    ]
    ordering_fields = [
        'name',
        'description',
        'price'
    ]

    @extend_schema(
        summary='Get one product by ID',
        description='Retrives product, returns 404',
        responses={
            200: ProductSerializer,
            404: OpenApiResponse(
                description='Empty responce, product by id not found')
        }
    )
    def retrieve(self, *args, **kwargs):
        """Метод расширения документации."""
        return super().retrieve(*args, **kwargs)

    @action(methods=['get'], detail=False)
    def download_csv(self, reuest: Request):
        response = HttpResponse(content_type='text/csv')
        filename = 'products-export.csv'
        response['Content-Disposition'] = f'attachment; filename={filename}'
        queryset = self.filter_queryset(self.get_queryset())
        fields = [
            'name',
            'description',
            'price'
        ]
        queryset = queryset.only(*fields)
        writer = DictWriter(response, fieldnames=fields)
        writer.writeheader()

        for product in queryset:
            writer.writerow({
                field: getattr(product, field)
                for field in fields
            })
        return response

    @action(methods=['post'], detail=False, parser_classes=[MultiPartParser])
    def upload_csv(self, request: Request):
        products = save_scv_products(
            request.FILES['file'].file,
            encoding=request.encoding
        )
        serializer = self.get_serializer(products, many=True)
        return Response(serializer.data)

    @method_decorator(cache_page(60))
    def list(self, *args, **kwargs):
        return super().list(*args, **kwargs)


class OrderViewSet(ModelViewSet):
    """Представление множества заказов."""

    queryset = Order.objects.all()
    serializer_class = OrderSerializer
    filter_backends = [
        SearchFilter,
        DjangoFilterBackend,
        OrderingFilter
    ]
    serch_fields = ['delivery_adress', 'user']
    filterset_fields = [
        'delivery_adress',
        'promocode',
        'created_at',
        'user'
    ]
    ordering_fields = [
        'delivery_adress',
        'promocode',
        'created_at',
        'user',
        'products'
    ]


class ShopIndexView(View):
    """Представление индекса. Тестовая страница."""

    def get(self, request: HttpRequest):
        """Метод обработки GET-запроса."""
        products = [
            ('Laptop', 1999),
            ('Desctop', 199999),
            ('Smartphone', 19999),
        ]
        context = {
            'timer': default_timer(),
            'products': products
        }
        logging.debug("Products for shop index: %s", products)
        logging.info('Rendering shop index')
        print('shop index context', context)
        return render(request, 'shopapp/shop-index.html', context=context)


class GroupsListView(View):
    """Представление списка групп."""

    def get(self, request: HttpRequest):
        """Метод обработки GET-запроса."""
        context = {
            'form': GroupForm(),
            'groups': Group.objects.all(),
        }
        return render(request, 'shopapp/droups-list.html', context=context)

    def post(self, request: HttpRequest):
        """Метод обработки POST-запроса."""
        form = GroupForm(request.POST)
        if form.is_valid():
            form.save()
        return redirect(request.path)


class ProductDetailsView(DetailView):
    """Представление деталей продукта."""

    template_name = 'shopapp/product-details.html'
    # model = Product
    queryset = Product.objects.prefetch_related('images')
    context_object_name = 'product'


# class ProductDetailsView(View):
#     def get(self, request:HttpRequest, pk: int):
#         product=get_object_or_404(Product, pk=pk)
#         context={
#             'product': product,
#         }
#         return render(
#                       request,
#                       'shopapp/product-details.html',
#                       context=context
#                       )


class ProductsListView(ListView):
    """Представление списка продуктов."""

    template_name = 'shopapp/products-list.html'
    # model=Product
    context_object_name = 'products'
    queryset = Product.objects.filter(archivade=False)


# class ProductsListView(TemplateView):
#     template_name='shopapp/products-list.html'
#
#     def get_context_data(self, **kwargs):
#         context=super().get_context_data(**kwargs)
#         context['products']=Product.objects.all()
#         return context

# def products_list(request: HttpRequest):
#     context={
#         'products': Product.objects.all(),
#     }
#     return render(request, 'shopapp/products-list.html', context=context)

# def orders_list(request: HttpRequest):
#     context={
#         'orders':
#         Order.objects.select_related('user').prefetch_related("products").all(),
#     }
#     return render(request, 'shopapp/order_list.html', context=context)

class OrdersListView(LoginRequiredMixin, ListView):
    """Представление для списка заказов."""

    queryset = (
        Order.objects.select_related('user').prefetch_related('products')
    )


class OrderDetailView(PermissionRequiredMixin, DetailView):
    """Представление для деталей заказа."""

    permission_required = 'shopapp.view_order'
    queryset = (
        Order.objects.select_related('user').prefetch_related('products')
    )


class OrderUpdateView(UpdateView):
    """Представление для обновления заказа."""

    model = Order
    fields = 'delivery_adress', 'promocode', 'user', 'products'
    template_name_suffix = '_update_form'

    def get_success_url(self):
        """Метод перенаправления ссылки."""
        return reverse('shopapp:order_detail', kwargs={'pk': self.object.pk})


class OrderDeleteView(DeleteView):
    """Представление для удаления заказа."""

    model = Order
    success_url = reverse_lazy('shopapp:orders')


class ProductCreateView(PermissionRequiredMixin, CreateView):
    """Представление для создания продукта."""

    permission_required = 'shopapp.add_product'
    model = Product
    fields = 'name', 'price', 'description', 'discount', 'preview'

    success_url = reverse_lazy('shopapp:products')

    def form_valid(self, form):
        """Метод проверки доступа."""
        form.instance.created_by = self.request.user
        return super().form_valid(form)


class ProductUpdateView(UserPassesTestMixin, UpdateView):
    """Представление для обновления продукта."""

    def test_func(self):
        """Метод проверки доступа."""
        if self.request.user.is_superuser:
            return True
        self.object = self.get_object()
        has_edit_perm = self.request.user.has_perm("shopapp.change_product")
        created_by_current_user = self.object.created_by == self.request.user
        return has_edit_perm and created_by_current_user

    model = Product
    # fields = 'name', 'price', 'description', 'discount', 'preview'
    form_class = ProductForm
    form_class = ProductForm
    template_name_suffix = '_update_form'

    def form_valid(self, form):
        """Проверка валидации."""
        response = super().form_valid(form)
        for image in form.files.getlist('images'):
            ProductImage.objects.create(
                product=self.object,
                image=image
            )
        return response

    def get_success_url(self):
        """Метод перенаправления ссылки."""
        return reverse(
            'shopapp:products_details',
            kwargs={'pk': self.object.pk})


class ProductDeleteView(DeleteView):
    """Представление удаления продукта."""

    # model = Product
    queryset = Product.objects.prefetch_related('images')
    success_url = reverse_lazy('shopapp:products')

    def form_valid(self, form):
        """Проверка валидации."""
        success_url = self.get_success_url()

mysite/shopapp/templates/shopapp/create-product.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Create product</title>
</head>
<body>
<h1>Create product</h1>
<div>
  <form method="post">
    {%csrf_token%}
    {{form.as_p}}
    <button type="submit">Create</button>
  </form>
    <a href="{%url 'shopapp:products'%}">Back to products</a>
</div>
</body>
</html>

mysite/shopapp/templates/shopapp/droups-list.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Groups list</title>
</head>
<body>
<h1>Groups:</h1>
<div>
    <form method="post">
        {%csrf_token%}
        {{form.as_p}}
        <button type="submit">Create</button>
    </form>
</div>
{%if not groups%}
<p>No group yet</p>
{%else%}
<ul>
    {%for group in groups%}
    <li>
        <p>{{group.name}}</p>
        <ul>
            {%for permission in group.permissions.all%}
            <li>
                {{permission.name}}
                {{permission.codename}}
            </li>
            {%endfor%}
        </ul>
    </li>
    {%endfor%}
</ul>
{%endif%}
</body>
</html>

mysite/shopapp/templates/shopapp/order_confirm_delete.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Delete Order</title>
</head>
<body>
<h1>Delete order</h1>
<div>
  <a href="{%url 'shopapp:order_detail' pk=object.pk%}">Return to order</a>
</div>
<div>
  <form method="post">
    {%csrf_token%}
    {{form.as_p}}
    <button type="submit">Delete</button>
  </form>
</div>
</body>
</html>

mysite/shopapp/templates/shopapp/order_detail.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Order Detail</title>
</head>
<body>
<h1>Order {{object.pk}}</h1>
<div>
    <p>Order by {%firstof object.user.first_name object.user.username%}</p>
    <p>Promocode: {{object.promocode}}</p>
    <p>Delivery adress: {{object.delivery_adress}}</p>
    <p>PK: {{object.pk}}</p>
    <div>
        <p>Product in order:</p>
        <ul>
            {%for product in object.products.all%}
            <li>{{product.name}} for ${{product.price}}</li>
            {%endfor%}
        </ul>
    </div>
</div>

<div><a href="{% url 'shopapp:order_update' pk=object.pk %}">Update</a></div>
<div>
<a href="{% url 'shopapp:order_delete' pk=object.pk %}">Delete</a>
</div>
<div>
    <a href="{%url 'shopapp:orders'%}">Back</a>
</div>
</body>
</html>

mysite/shopapp/templates/shopapp/order_list.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Orders</title>
</head>
<body>
<h1>Orders:</h1>

{% if object_list %}
<ul>
{%for order in object_list%}
    <a href="{%url 'shopapp:order_detail' pk=order.pk%}">Details {{order.pk}}</a>
    <li>
        <p>{{order.user}}</p>
        <ol>
            {%for product in order.products.all%}
                <li>{{product.name}} for {{product.price}}</li>
            {%endfor%}
        </ol>
    </li>
    <br>
    <br>
    {%endfor%}
</ul>
{%else%}
<p>No orders</p>
{%endif%}
<div>
    <a href="{%url 'shopapp:create_order'%}">Create new product</a>
</div>
</body>
</html>

mysite/shopapp/templates/shopapp/order_update_form.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Update order</title>
</head>
<body>
<h1>Update order</h1>
<div>
    <form method="post">
        {%csrf_token%}
        {{form.as_p}}
        <button type="submit">Update</button>
    </form>
</div>
<a href="{%url 'shopapp:order_detail' pk=object.pk%}">Back to product {{object.pk}}</a>
</body>
</html>

mysite/shopapp/templates/shopapp/orders_change_list.html
{%extends 'admin/change_list.html' %}

{%block object-tools-items%}

<li>
  <a href="{%url 'admin:import_orders_csv'%}" class="addLink">
    Import CSV
  </a>
</li>
{{block.super}}
{%endblock%}

mysite/shopapp/templates/shopapp/product-details.html
<!DOCTYPE html>
<html lang="en">
{% load i18n %}
<head>

    <meta charset="UTF-8">
    <title>{%translate 'Prouct' %} {{prouct.pk}}</title>
</head>
<body>
<h1>{%translate 'Product' %} {{product.name}}</h1>
<div>
    {%if product.preview %}
    <h3>{%translate 'Preview' %}:</h3>
    <img src="{{product.preview.url}}" alt="{{product.preview.name}}" width="100" height="100">
    {%endif%}
    <h3>{%translate 'Images' %}.</h3>
    {%blocktranslate count count_img=product.images.all|length%}
    <p>Available one image</p>
    {%plural %}
    <p>Avalible {{count_img}} images.</p>
    {%endblocktranslate%}
    {% for image in product.images.all %}
    <div>
        <img src="{{image.image.url}}" alt="{{image.image.name}}" width="100" height="100">
        <p>{{image.description}}</p>
    </div>
    {%endfor%}

    <p>{% translate 'Description'%}: {{product.description}}</p>
    <p>{% translate 'Price'%}: {{product.price}}</p>
    <p>{% translate 'Discount'%}: {{product.discount}}</p>
    <p>{% translate 'Archived'%}: {{product.archivade}}</p>
    <p>{% translate 'Creater'%}: {{product.created_by.username}}</p>

</div>
<div>
    {%if user.is_superuser or perms.shopapp.change_product and user == product.created_by%}
<a href="{%url 'shopapp:products_update' pk=product.pk%}">{% translate 'Update' %}</a>
    {%endif%}
</div>
<a href="{%url 'shopapp:products_delete' pk=product.pk%}">{%translate 'Delete' %}</a>
</div>
<div>
<a href="{%url 'shopapp:products'%}">{%translate 'Back' %}</a>
</div>
</body>
</html>

mysite/shopapp/templates/shopapp/product_confirm_delete.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Confirm Delete</title>
</head>
<body>
<h1>Confirm Delete {{product.name}}</h1>
<h2><a href="{%url 'shopapp:products_details' pk=object.pk%}">Return to product</a></h2>

<div>
  <form method="post">
    {%csrf_token%}
    {{form.as_p}}
    <button type="submit">Delete</button>
  </form>
</div>
</body>
</html>

mysite/shopapp/templates/shopapp/product_form.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Create product</title>
</head>
<body>
<h1>Create product</h1>
<div>
    <form method="post">
        {%csrf_token%}
        {{form.as_p}}
        <button type="submit">Create</button>
    </form>
</div>
<a href="{%url 'shopapp:products'%}">Back</a>
</body>
</html>

mysite/shopapp/templates/shopapp/products-list.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Products</title>
</head>
<body>
<h1>Products:</h1>
{% if products %}
<ul>
    {%for product in products%}
    <li>
        <p><a href="{%url 'shopapp:products_details' pk=product.pk%}">Name: {{product.name}}</a></p>
    <p>Price: {{product.price}}</p>
    <p>Discount: {{product.discount}}</p>
    </li>
    {%endfor%}
</ul>
{%else%}
<p>No product</p>

{% endif %}
<!--<div>-->
<!--    <a href="{%url 'shopapp:create_product'%}">Create new product</a>-->
<!--</div>-->
{% if perms.shopapp.add_product%}
<a href="{%url 'shopapp:product_create'%}">Create product</a>
{%endif%}
</body>
</html>

mysite/shopapp/templates/shopapp/products_change_list.html
{%extends 'admin/change_list.html' %}

{%block object-tools-items%}

<li>
  <a href="{%url 'admin:import_products_csv'%}" class="addLink">
    Import CSV
  </a>
</li>
{{block.super}}
{%endblock%}

mysite/shopapp/templates/shopapp/shop-index.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Shop Index</title>
</head>
<body>
{% load cache%}
<h1>Main Shop app</h1>

{% cache 100 time %}
<p>
    Time: {{timer}}
</p>
{% endcache %}

<h2>Products:</h2>
<div>
    <ul>
        {% for name, price in products %}
        <li>{{name}} for ${{price}}</li>
        {% empty %}
        No product
        {% endfor %}
    </ul>
</div>
</body>
</html>

mysite/shopapp/templates/shopapp/user-orders.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Заказы пользователя {{user.username}}</title>
</head>
<body>
{% load cache%}
<p>Пользователь {{user.username}}</p>
    <p>Username: {{user.username}}</p>
    <p>Firstname: {{user.first_name}}</p>
    <p>Lastname: {{user.last_name}}</p>
    <p>Email: {{user.email}}</p>
    <p>Bio: {{form.bio}}</p>
{% if orders %}


{% cache 100 info_order %}
{% for order in orders %}
 <div>
   <a href="{% url 'shopapp:order_detail' pk=order.pk%}">{{order.delivery_adress}}</a>
 </div>
{%endfor%}
{% endcache %}

{% else %}
<p>Заказов у пользователя ещё нет</p>
{% endif %}

</body>
</html>